Menu

- Learn
- Documentation
  - Language Reference
  - Library Reference
  - Command-line Reference
  - Feature Overview
  - Articles
- Packages
- Community
  - Blog
  - Orgs using D
  - Twitter
  - Forums
  - IRC
  - Wiki
  - GitHub
  - Issues
  - Get involved
  - Foundation
  - Donate
- Resources
  - Books
  - Tutorials
  - Tools
  - Editors
  - IDEs
  - Visual D
  - Acknowledgments
  - D Style
  - Glossary
  - Sitemap

Search
Report a bug
If you spot a problem with this page, click here to create a Bugzilla issue.
Improve this page
Quickly fork, edit online, and submit a pull request for this page. Requires a signed-in GitHub account. This works well for small changes. If you'd like to make larger changes you may want to consider using a local clone.

# ddmd.cond

Compiler implementation of the D programming language.
Authors:
Walter Bright
License:
Boost License 1.0

Source: cond.d

abstract class `Condition`: ddmd.root.rootobject.RootObject;
class `StaticForeach`: ddmd.root.rootobject.RootObject;
  Implements common functionality for StaticForeachDeclaration and StaticForeachStatement This performs the necessary lowerings before ddmd.statementsem.makeTupleForeach can be used to expand the corresponding static foreach declaration or statement.
  ForeachStatement `aggrfe`;
    Not null iff the static foreach is over an aggregate. In this case, it contains the corresponding ForeachStatement. For StaticForeachDeclaration, the body is null.
  ForeachRangeStatement `rangefe`;
    Not null iff the static foreach is over a range. Exactly one of the aggrefe and `rangefe` fields is not `null`. See aggrfe field for more details.
  bool `needExpansion`;
    `true` if it is necessary to expand a tuple into multiple variables (see lowerNonArrayAggregate).
  final void `prepare`(Scope* `sc`);
    Perform static foreach lowerings that are necessary in order to finally expand the static foreach using ddmd.statementsem.makeTupleForeach.
  final bool `ready`();
    Returns:
    true iff `ready` to call ddmd.statementsem.makeTupleForeach.
abstract class `DVCondition`: ddmd.cond.Condition;
class `DebugCondition`: ddmd.cond.DVCondition;
  static void `setGlobalLevel`(uint `level`);
    Set the global debug `level`
    Only called from the driver
    Parameters:

    uint `level` | Integer literal to set the global version to

  deprecated static void `addGlobalIdent`(const(char)* `ident`);
  static void `addGlobalIdent`(string `ident`);
  static void `addGlobalIdent`(const(char)[] `ident`);
    Add an user-supplied identifier to the list of global debug identifiers
    Can be called from either the driver or a debug = Ident; statement. Unlike version identifier, there isn't any reserved debug identifier so no validation takes place.
    Parameters:

    const(char)* `ident` | identifier to add

  this(Module `mod`, uint `level`, Identifier `ident`);
    Instantiate a new DebugCondition
    Parameters:

    Module `mod` | Module this node belongs to
    uint `level` | Minimum global `level` this condition needs to pass. Only used if `ident` is null.
    Identifier `ident` | Identifier required for this condition to pass. If null, this conditiion will use an integer `level`.

class `VersionCondition`: ddmd.cond.DVCondition;
  Node to represent a version condition
  A version condition is of the form:

      version (Identifier)

  In user code. This class also provides means to add version identifier to the list of global (cross module) identifiers.
  static void `setGlobalLevel`(uint `level`);
    Set the global version `level`
    Only called from the driver
    Parameters:

    uint `level` | Integer literal to set the global version to

  static void `checkReserved`(Loc `loc`, const(char)[] `ident`);
    Raises an error if a version identifier is reserved.
    Called when setting a version identifier, e.g. -version=identifier parameter to the compiler or version = Foo in user code.
    Parameters:

    Loc `loc` | Where the identifier is set
    const(char)[] `ident` | identifier being checked (`ident`[$] must be '\0')

  deprecated static void `addGlobalIdent`(const(char)* `ident`);
  static void `addGlobalIdent`(string `ident`);
  static void `addGlobalIdent`(const(char)[] `ident`);
    Add an user-supplied global identifier to the list
    Only called from the driver for -version=Ident parameters. Will raise an error if the identifier is reserved.
    Parameters:

    const(char)* `ident` | identifier to add

  deprecated static void `addPredefinedGlobalIdent`(const(char)* `ident`);
  static void `addPredefinedGlobalIdent`(string `ident`);
  static void `addPredefinedGlobalIdent`(const(char)[] `ident`);
    Add any global identifier to the list, without checking if it's predefined
    Only called from the driver after platform detection, and internally.
    Parameters:

    const(char)* `ident` | identifier to add (`ident`[$] must be '\0')

  this(Module `mod`, uint `level`, Identifier `ident`);
    Instantiate a new VersionCondition
    Parameters:

    Module `mod` | Module this node belongs to
    uint `level` | Minimum global `level` this condition needs to pass. Only used if `ident` is null.
    Identifier `ident` | Identifier required for this condition to pass. If null, this conditiion will use an integer `level`.

class `StaticIfCondition`: ddmd.cond.Condition;

Copyright © 1999-2017 by the D Language Foundation | Page generated by Ddoc on Fri Sep 1 12:52:31 2017